* {
    box-sizing: border-box;
}

.box-animate {
    position: relative;
    padding: 300px 50px;
    border: 5px solid;
}

.box {
    width: 200px;
    height: 200px;
    transform-style: preserve-3d;
    margin: 0 auto;
}

.animate {
    animation-timing-function: linear;
    animation-iteration-count: infinite;
    animation-duration: 12s;
}

.rotate {
    animation-name: rotate;
}

.moveFront, .moveBack {
    position: absolute;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
    text-align: center;
    color: white;
    transform-style: preserve-3d;
}

.moveFront {
    animation-name: moveFront;
    background: red;
}

.moveBack {
    animation-name: moveBack;
    background: blue;
}

.front::before, .back::before {
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    width: inherit;
    height: inherit;
    background-color: inherit;
    transform: translateZ(-1px);

}

@keyframes rotate {
    0% {
        transform: rotateY(0deg);
    }
    100% {
        transform: rotateY(360deg);
    }
}

@keyframes moveFront {
    0% {
        transform: rotateZ(0deg) translateZ(120px);
    }
    100% {
        transform: rotateZ(360deg) translateZ(120px);
    }
}

@keyframes moveBack {
    0% {
        transform: rotateZ(360deg) translateZ(20px) rotateY(180deg);
    }
    100% {
        transform: rotateZ(0deg) translateZ(20px) rotateY(180deg);
    }
}